/**************************************************************
 * Send any comments or questions to: OTSO-Bug@tel.vtt.fi
 *
 * Name: /home/users/otso/official/otso/enviros/device/include/SCCS/s.device.hxx
 * Vers: 5.2    Time: 92/08/04, 11:01:02
 **************************************************************/

/***************************************************************
* Copyright (c) 1992      Technical Research Centre of Finland (VTT)
*
* Permission to use, copy, modify, and distribute this software and its
* documentation for any purpose and without fee is hereby granted, provided
* that this notice and the reference to this notice appearing in each software
* module be retained unaltered, and that the name of any contributors shall not
* be used in advertising or publicity pertaining to distribution of the software
* without specific written prior permission.  No contributor makes any
* representations about the suitability of this software for any purpose.
* It is provided "as is" without any express or limited warranty.
*
*			NO WARRANTY
*
* ALL CONTRIBUTORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS.  IN NO
* EVENT SHALL ANY CONTRIBUTOR BE LIABLE FOR ANY SPECIAL, PUNITIVE, INDIRECT OR
* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
* DATA, OR PROFITS, WHETHER IN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
* TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH, THE USE OR PERFORMANCE
* OF THIS SOFTWARE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THIS
* SOFTWARE IS WITH YOU.  SHOULD THIS SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE
* COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
*
* As used above, "contributor" includes, but is not limited to :
*        The Technical Research Centre of Finland
***************************************************************/


/******************************************************
* NAME
*	device.hxx
*
* PURPOSE
*	Operating System dependent device files are included.
*	
*	Devices and Device Table are implemented in a OS
*	specific way.
*
*	Definition of pGlobalDevices, a pointer to
*	a single Global Device Table for the OTSO system.
******************************************************/

#if 0	/* to be deleted */
#ifndef OBJECT_HXX
# include "object.hxx"
#endif
#endif /* 0 */

#if BSD
# include	"devbsd.hxx"
#else
# if USG
#  include	"devsysv.hxx"
# else
#  if MSDOS
#   include	"devmsdos.hxx"
#  endif	/* MSDOS */
# endif		/* USG - System 5 Unix */
#endif		/* BSD UNIX */

/*
* 'pGlobalDevices' is a pointer to a default Global Device Table.
* The user must declare it (see init2.inc for example).
* By default, Device ctors insert themselves into pGlobalDevices.
*/
extern DeviceTable* pGlobalDevices;

