/**************************************************************
 *
 *  VALTION TEKNILLINEN TUTKIMUSKESKUS (VTT/TEL/TIV)
 *  Otakaari 7 B
 *  02150 Espoo
 *  FINLAND
 *
 *  OTSO Source Code Control System, 12.7.89
 *
 *  Name:	/home/users/otso/official/otso/protocols/3/cons/all/SCCS/s.cons_peer.hx
 *  Version:	1.1
 *  Time:	91/07/17, 14:13:53
 *
 **************************************************************/


/**********************************************************************
* NAME: cons_peer.hxx
* PURPOSE: Connection Oriented Network Service (CONS)
*	Peer protocol PDU definitions.
**********************************************************************/

/**********************************************************************
NetPeer is a virtual connectionless peer protocol. It defines the
interface between two connectionless nodes in dvops. This can be
used to define different kinds of virtual sublayers.
**********************************************************************/

interface class NetPeer {
public:
  virtual async N_CR (
    NSAPaddr source_addr, NSAPaddr dest_addr, slong qos, Frame data
  ) = 0;

  virtual async N_CC (NSAPaddr resp_addr, slong qos, Frame data) = 0;

  virtual async N_DR (
    slong originator, slong reason, Frame data, NSAPaddr resp_addr
  ) = 0;

  virtual async N_DT (Frame data) = 0;
};

